<template>
    <div
        @click="logout"
        class="flex gap-2.5 align-middle items-center text-secondary mb-6 px-8 cursor-pointer hover:text-tertiary transition-colors duration-300 transform"
    >
        <p class="pt-0.5 text-base font-medium">
          <v-icon class="!text-lg text-secondary" icon="mdi-logout"></v-icon>&nbsp;{{ translate('menu.log_out') }}
        </p>
    </div>

    <v-row
        class="text-secondary border-t border-menu-toggle-default py-6 px-8 !mb-0 cursor-pointer"
        @click="menu = !menu"
    >
        <div class="flex flex-col leading-4 cols-10 text-secondary my-1 mr-2">
            <p id="current-user-name" class="text-base mb-1">
                {{ userFullName ?? 'User' }}
            </p>
            <p id="current-user-email" class="text-xs mb-4" v-if="userStore.getLoggedInUser.email">
                {{ userStore.getLoggedInUser.email }}
            </p>
        </div>

        <!-- v-if="currentBranch" -->
        <div class="text-center cols-2 !p-0 parent-menu">
            <v-menu v-model="menu" :close-on-content-click="true">
                <template v-slot:activator="{ props }">
                  <v-icon v-bind="props">mdi-cog-outline</v-icon>&nbsp;Customize <v-icon v-bind="props">{{ menu ? 'mdi-chevron-down' : 'mdi-chevron-up' }}</v-icon>
                </template>

                <v-card class="!p-0 position-on-menu">
                    <v-list bg-color="#F2F2F2">
                        <v-list-item>
                            <p id="current-user-email" class="text-xs">
                                {{ userStore.getLoggedInUser.email }}
                            </p>
                        </v-list-item>
                    </v-list>

                    <v-divider></v-divider>

                    <v-list>
                        <v-list-item
                            class="cursor-pointer mb-2"
                            key="option"
                            @click="customize()"
                        >
                            <p class="text-base">
                              Toggle option option
                            </p>
                        </v-list-item>
                    </v-list>
                </v-card>
            </v-menu>
        </div>
    </v-row>
</template>

<script lang="ts" setup>
import { useI18n } from 'vue-i18n';
import { storeFactory } from '@/main';
import { onMounted, ref } from 'vue';

const userStore = storeFactory.userStore;
const pdToast = storeFactory.toastStore;

const { t: translate } = useI18n();

const menu = ref(false);
const userFullName = ref('');
const logout = async () => {
    userStore.logout().then(() => {
        pdToast.success(translate('notifications.logout_success'), '');
    });
};

const customize = (): void => {
    storeFactory.modalStore.show({
        title: translate('modal.logout.title'),
        icon: 'mdi-account-circle',
        body: translate('modal.logout.message', ),
        primary: {
            action: async () => {
               console.log('TODO');
                // await userStore
                //     .refreshToken({
                //         ...(await userStore.findCompany(companyBranch.company_id)),
                //         company_id: companyBranch.company_id,
                //         company_branch_id: companyBranch.id,
                //     })
                //     .then(() => {
                //         currentBranchData.value = loadCurrentBranch();
                //         return currentBranchData.value;
                //     });
                //
                // location.reload();
            },
            type: 'success',
            label: translate('global.yes'),
        },
        cancel: {
            action: () => {},
        },
    });
};

onMounted(() => {
    // nothing
});
</script>

<style>
.parent-menu {
    position: relative;
}

.position-on-menu {
    padding: 0 !important;
    left: -105px !important;
    position: absolute;
    height: auto !important;
    bottom: 5px;
    width: max-content;
    max-width: 203px;
    border: 1px solid #e6e6e6 !important;
}

.v-menu > .v-overlay__content:has(> .position-on-menu) {
    left: 131px !important;
}
</style>
